// #define _GLIBCXX_DEBUG
#include <bits/stdc++.h>

using namespace std;

#define ll long long
#define all(a) (a).begin(), (a).end()

int main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int n, q;
    cin >> n >> q;
    vector<int> a(n);
    for (int i = 0; i < n; i++) cin >> a[i];
    while (q--) {
        int l, r;
        cin >> l >> r;
        l--, r--;
        if (l % 2 == 1) l++;
        if (r % 2 == 1) r--;
        cout << max(0, r -l ) << '\n';
    }
}